﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using System.Windows.Forms;

namespace CubeExplorerUI
{
    class Origens
    {
        string connectionString = Properties.Settings.Default.ConnectionString;
        SqlConnection conn;

        public Origens()
        {
            conn = new SqlConnection(connectionString);
        }

        public DataTable LListarOrigens()
        {
            // Obrir connexió  
            conn.Open();

            // Llistar tots els cubs
            SqlDataAdapter da = new SqlDataAdapter("[LlistarOrigens]", conn);
            DataTable dt = new DataTable();
            da.Fill(dt);
            conn.Close();

            return (dt);
        }

        public void EliminarOrigen(int Id)
        {
            
            // ELiminar tots els camps d'un cub
            SqlCommand cmd = new SqlCommand("EliminarOrigen", conn);
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("@Id", SqlDbType.Int);
            cmd.Parameters["@Id"].Value = Id;

            // Obrir connexió  
            conn.Open();
            cmd.ExecuteNonQuery();
            conn.Close();
        }

        public void CrearOrigen(string Nom, string Connexio)
        {
            try
            {
                // Procediment emmagatzemat de creació del cub
                SqlCommand cmd = new SqlCommand("CrearOrigen", conn);
                cmd.CommandType = CommandType.StoredProcedure;

                SqlParameter p1 = new SqlParameter("@Nom", Nom);
                p1.SqlDbType = SqlDbType.NVarChar;
                p1.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p1);

                SqlParameter p2 = new SqlParameter("@Connexio", Connexio);
                p2.SqlDbType = SqlDbType.NVarChar;
                p2.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p2);

                conn.Open();
                cmd.ExecuteNonQuery();
                conn.Close();

            }
            catch (Exception e)
            {
                MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
            }  
        }
        
    }
}
