﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Forms;

namespace CubeExplorerUI
{
    /// <summary>
    /// Lógica de interacción para OrigensDades.xaml
    /// </summary>
    public partial class OrigensDades : Window
    {
        Origens origens;
        CarregadorDades loader=null;
        System.Data.DataRowView current;

        
        public CarregadorDades Loader{
            get { return (loader); }
            set { loader = value; }
        }

        public OrigensDades(ref CarregadorDades loader)
        {
            InitializeComponent();

            origens = new Origens();
            this.loader = loader;

            gridControl1.ItemsSource = origens.LListarOrigens();
            //tableView1.AutoWidth = false;
            //tableView1.BestFitColumns();
            gridColumn1.Width = 50;
            gridColumn2.Width = 100;
            gridColumn3.Width = 500;
           
           
        }



        private void btnNou_Click(object sender, RoutedEventArgs e)
        {
            // Crear una connexió nova
            if (!loader.Connectar())
                return;


            // Demanar el nom de l'origen de dades
            string nom="";
            if (Utils.InputBox("Cube Explorer", "Introdueix el nom del origen de dades", ref nom) ==
                System.Windows.Forms.DialogResult.Cancel)
                return;
                        
            // Crear nou origen de dades
            origens.CrearOrigen(nom,loader.Connexio);
            
            // Refresc
            gridControl1.ItemsSource = origens.LListarOrigens();
            tableView1.BestFitColumns();
           
            DialogResult = true;
            Close();
        }

        private void btnSelect_Click(object sender, RoutedEventArgs e)
        {
            current = (System.Data.DataRowView)gridControl1.GetFocusedRow();

            if (current == null) return;

            // Connectar a partir de la cadena de connexió
            if (!loader.Connectar((string)current.Row.ItemArray[2])) 
                return;
            loader.CarregarCataleg();
            DialogResult = true;
            Close();

        }

        private void btnEliminar_Click(object sender, RoutedEventArgs e)
        {
            current = (System.Data.DataRowView)gridControl1.GetFocusedRow();

            if (current == null) return;

            string message = "Vol eliminar el origen de dades " + (string)current.Row.ItemArray[1] + " ?";
            const string caption = "Missatge";
            var result = System.Windows.Forms.MessageBox.Show(message, caption,
                         MessageBoxButtons.YesNo,
                         MessageBoxIcon.Question);

            if (result == System.Windows.Forms.DialogResult.Yes)
            {
                origens.EliminarOrigen((int)current.Row.ItemArray[0]);
                // Refresc
                gridControl1.ItemsSource = origens.LListarOrigens();
                gridColumn1.Width = 50;
                gridColumn2.Width = 100;
                gridColumn3.Width = 500;

            }
        }

        private void btnSortir_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
        }
    }
}
