﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.Collections.ObjectModel;
using DevExpress.Xpf.Editors.Settings;


namespace CubeExplorerUI
{
    
    public partial class SeleccioCamps : Window
    {
        DataSet ds;
        public LlistaCamps Camps { get; set; }
                
        
        public SeleccioCamps(DataSet ds, LlistaCamps camps)
        {
            InitializeComponent();

                       
            this.ds = ds;
            Camps = camps;
                         
            // TODO: Validacions
            // 1 - No permetre camps repetits, caldria buidar la taula colNoms
            // 2 - El camp de dades és l'únic que pot tenir assignat format
            // 3 - Almenys un camp de dades
            
            ObservableCollection<string> colNoms = new ObservableCollection<string>();

            foreach (DataColumn col in ds.Tables[0].Columns)
            {
                colNoms.Add(col.ColumnName);
            }

            ObservableCollection<string> colAreas = new ObservableCollection<string>();

            colAreas.Add("Files");
            colAreas.Add("Columnes");
            colAreas.Add("Filtres");
            colAreas.Add("Dades");
 

            ObservableCollection<string> colFormat= new ObservableCollection<string>();

            colFormat.Add("Moneda");
            colFormat.Add("Moneda amb 4 decimals");
            colFormat.Add("Decimal");
            colFormat.Add("Científic");
            colFormat.Add("Fixe");
            colFormat.Add("General");
            colFormat.Add("Número");
            colFormat.Add("Número sense decimals");
            colFormat.Add("Número amb 4 decimals");
            colFormat.Add("Percentatge");
            colFormat.Add("Percentatge sense decimals");
            colFormat.Add("Percentatge amb 4 decimals");
            


 
            /*
            321543.23 - Currency: {0:c} $321,543.23
            321543.23 - Currency with 4 decimals: {0:c4} $321,543.2300
            321545 - Decimal: {0:d} 321545
            321543.23 - Scientific: {0:e} 3.215432e+005
            321543.23 - Fixed: {0:f3} 321543.230
            321543.23 - General: {0:g} 321543.23
            321543.23 - Number: {0:n} 321,543.23
            321543.23 - Number with no decimals: {0:n0} 321,543
            321543.23 - Number with 4 decimals: {0:n4} 321,543.2300
            321543.23 - Percent: {0:p} 32,154,323.00 %
            321543.23 - Percent with no decimals: {0:p0} 32,154,323 %
            321543.23 - Percent with 4 decimals: {0:p4} 32,154,323.0000 %

            */

                 
            ((ComboBoxEditSettings)gridControl1.Columns["Camp"].EditSettings).ItemsSource = colNoms;
            ((ComboBoxEditSettings)gridControl1.Columns["Area"].EditSettings).ItemsSource = colAreas;
            ((ComboBoxEditSettings)gridControl1.Columns["Format"].EditSettings).ItemsSource = colFormat;

            // Per defecte es crea un camp
            if (Camps.GetData().Count == 0)
            {
                Camps.GetData().Add(new FormatCamp());
            }

            this.gridControl1.ItemsSource = Camps.GetData();
                                  
        }



        private void button1_Click(object sender, RoutedEventArgs e)
        {
            int d=0;
            // Comprovar que almenys hi ha un camp de dades
            foreach (FormatCamp fc in (List<FormatCamp>)gridControl1.ItemsSource)
            {
                if (fc.Area == "Dades") d++;
            }

            if (d == 0)
            {
                MessageBox.Show("Cal indicar com a mínim un camp de dades", "CubeExplorer");
                return;
            }
            else
            {
                DialogResult = true;
                Close();
            }
        }

        private void btnNou_Click(object sender, RoutedEventArgs e)
        {
           Camps.GetData().Add(new FormatCamp());
           this.gridControl1.RefreshData();
        }

        private void btnSortir_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
            Close();
        }
    }
}
