﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using DevExpress.Xpf.Core;
using System.Data;


namespace CubeExplorerUI
{
    /// <summary>
    /// Interaction logic for VisorCubs.xaml
    /// </summary>
    public partial class VisorCubs : Window
    {
        private int id;
        private string ruta;

        public event RefrescDadesHandler OnRefrescarDades;

        public VisorCubs(int id, string nom,string ruta,int tipus)
        {
            InitializeComponent();
            this.Title = nom;
            this.id = id;
            this.ruta = ruta;

            if (tipus == 0)
            {
                stackPanel1.Width = 0;
                stackPanel1.SetVisible(false);
            }
           

            try
            {
                pivotGridControl1.RestorePivotGridFromFile(ruta);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
            }
        }

        public void Refrescar(DataSet ds)
        {
            pivotGridControl1.DataSource = ds.Tables[0];
            pivotGridControl1.SavePivotGridToFile(ruta);
            pivotGridControl1.RefreshData();
        }


        private void btnRefrescar_Click(object sender, RoutedEventArgs e)
        {
            OnRefrescarDades(id);
        }
    }
}
