﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Windows.Forms;

namespace CubeExplorerUI
{
     
    class Seccions
    {
        string connectionString = Properties.Settings.Default.ConnectionString;
        SqlConnection conn;

        public Seccions()
        {
          conn = new SqlConnection(connectionString);
        }


        public DataTable LlistarSeccions()
        {
            try
            {
                // Obrir connexió  
                conn.Open();

                // Llistar tots els cubs
                SqlDataAdapter da = new SqlDataAdapter("[LlistarSeccions]", conn);
                DataTable dt = new DataTable();
                da.Fill(dt);
                conn.Close();

                return (dt);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
                return null;
            }
        }


        public int CrearSeccio(string nom, string descripcio, string carpeta)
        {
            try
            {
                // Validar secció
                SqlCommand cmd = new SqlCommand("CrearSeccio", conn);
                cmd.CommandType = CommandType.StoredProcedure;

                SqlParameter p1 = new SqlParameter("@Nom", nom);
                p1.SqlDbType = SqlDbType.Char;
                p1.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p1);

                SqlParameter p2 = new SqlParameter("@Descripcio", descripcio);
                p2.SqlDbType = SqlDbType.Char;
                p2.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p2);

                SqlParameter p3 = new SqlParameter("@Carpeta", carpeta);
                p3.SqlDbType = SqlDbType.Char;
                p3.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p3);

                // Id de la secció creada
                SqlParameter pRet = new SqlParameter("@RetValue", SqlDbType.Int);
                pRet.Direction = ParameterDirection.ReturnValue;
                cmd.Parameters.Add(pRet);

                conn.Open();
                cmd.ExecuteNonQuery();
                int Id = (int)cmd.Parameters["@RetValue"].Value;
                conn.Close();
                return Id;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
                return -1;
            }
        }


        public void ModificarSeccio(int id, string nom, string descripcio, string carpeta)
        {
            try
            {
                // Obrir connexió  
                conn.Open();

                // Validar usuari
                SqlCommand cmd = new SqlCommand("ModificarSeccio", conn);
                cmd.CommandType = CommandType.StoredProcedure;

                SqlParameter p0 = new SqlParameter("@IdSeccio", id);
                p0.SqlDbType = SqlDbType.Int;
                p0.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p0);

                SqlParameter p1 = new SqlParameter("@Nom", nom);
                p1.SqlDbType = SqlDbType.Char;
                p1.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p1);

                SqlParameter p2 = new SqlParameter("@Descripcio", descripcio);
                p2.SqlDbType = SqlDbType.Char;
                p2.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p2);

                SqlParameter p3 = new SqlParameter("@Carpeta", carpeta);
                p3.SqlDbType = SqlDbType.Char;
                p3.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p3);

                cmd.ExecuteNonQuery();

                conn.Close();
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
            }
        }

        public void EliminarSeccio(int id)
        {
            try
            {
                // Obrir connexió  
                conn.Open();

                SqlCommand cmd = new SqlCommand("EliminarSeccio", conn);
                cmd.CommandType = CommandType.StoredProcedure;

                SqlParameter p0 = new SqlParameter("@IdSeccio", id);
                p0.SqlDbType = SqlDbType.Int;
                p0.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p0);

                cmd.ExecuteNonQuery();

                conn.Close();
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
            }
        }  




    

    }
}
