﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using System.Windows.Forms;


namespace CubeExplorerUI
{
    public class UsuariDB
    {
        public int id { get; set; }
        public string nom { get; set; }
        public string perfil { get; set; }
    }

    public class Usuaris    {
       string connectionString = Properties.Settings.Default.ConnectionString;
       bool validat;
       SqlConnection conn;

       public int nivell { get; set; }

       public Usuaris()
        {
            validat = false;
            conn = new SqlConnection(connectionString);

        }


       public DataRow ObtenirUsuari(int Id)
       {
         try {
               // Obrir connexió  
               conn.Open();

               // Validar usuari
               SqlDataAdapter da = new SqlDataAdapter("Select Id,Nom,ParaulaClau,Perfil from Usuaris where Id=" + 
                   Convert.ToString (Id), conn);
               DataTable dt = new DataTable();
               da.Fill(dt);
               conn.Close();

               if (dt.Rows.Count > 0)
                   return (dt.Rows[0]);
               else
                   return null; 
         }
         catch (Exception e)
         {
             MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
             return null;
         }  

       }

       public List<UsuariDB> LlistarUsuaris()
       {
           try {
               // Abrir connexió  
               conn.Open();

               // Validar usuari
               SqlDataAdapter da = new SqlDataAdapter("[LlistarUsuaris]",conn);
               DataTable dt = new DataTable();   

               da.Fill(dt);
               conn.Close(); 

               // Conversió del datatable en una llista
               List<UsuariDB> list = new List<UsuariDB>();

               foreach (DataRow row in dt.Rows) {
                   UsuariDB usuari = new UsuariDB();

                   usuari.id = Convert.ToInt32 (row["Id"]);
                   usuari.nom = Convert.ToString(row["Nom"]);

                   switch (Convert.ToInt32 (row["Perfil"])) {
                        case 1:
                           usuari.perfil = "Administrador";
                        break;

                        case 2:
                            usuari.perfil = "Desenvolupador";
                        break;

                        case 3:
                            usuari.perfil = "Usuari";
                        break;
                   }

                   list.Add(usuari);
               }
                             

               return (list);
            } 
            catch (Exception e)
            {
                MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
                return null;
            }
        }

                
        public bool ValidarUsuari(string usuari,string password)
        {
            try {
                // Obrir connexió  
                conn.Open();

                // Validar usuari
                SqlCommand cmd = new SqlCommand("ValidarUsuari", conn);
                cmd.CommandType = CommandType.StoredProcedure;


                SqlParameter p1 = new SqlParameter("@Nom", usuari);
                p1.SqlDbType = SqlDbType.Char;
                p1.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p1);

                SqlParameter p2 = new SqlParameter("@ParaulaClau", password);
                p2.SqlDbType = SqlDbType.Char;
                p2.Direction = ParameterDirection.Input;
                cmd.Parameters.Add(p2);

                SqlParameter ps = new SqlParameter("@Ret", SqlDbType.Int);
                ps.Direction = ParameterDirection.ReturnValue;
                cmd.Parameters.Add(ps);


                cmd.ExecuteNonQuery();

                nivell = Convert.ToInt16(cmd.Parameters["@Ret"].Value);

                conn.Close();

                validat = nivell > 0;
                return validat;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
                return false;
            }
           }

           public int CrearUsuari(string usuari, string password, int perfil)
            {
                try
                {
                    // Validar usuari
                    SqlCommand cmd = new SqlCommand("CrearUsuari", conn);
                    cmd.CommandType = CommandType.StoredProcedure;

                    SqlParameter p1 = new SqlParameter("@Nom", usuari);
                    p1.SqlDbType = SqlDbType.Char;
                    p1.Direction = ParameterDirection.Input;
                    cmd.Parameters.Add(p1);

                    SqlParameter p2 = new SqlParameter("@ParaulaClau", password);
                    p2.SqlDbType = SqlDbType.Char;
                    p2.Direction = ParameterDirection.Input;
                    cmd.Parameters.Add(p2);

                    SqlParameter p3 = new SqlParameter("@Perfil", perfil);
                    p3.SqlDbType = SqlDbType.Int;
                    p3.Direction = ParameterDirection.Input;
                    cmd.Parameters.Add(p3);

                    // Id del usuari creat
                    SqlParameter pRet = new SqlParameter("@RetValue", SqlDbType.Int);
                    pRet.Direction = ParameterDirection.ReturnValue;
                    cmd.Parameters.Add(pRet);

                    conn.Open();
                    cmd.ExecuteNonQuery();
                    int Id = (int)cmd.Parameters["@RetValue"].Value;
                    conn.Close();
                    return Id;
                } 
                catch (Exception e)
                {
                    MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
                    return -1;
                }
           }


           public void ModificarUsuari(int id, string usuari, string password, int perfil)
           {
               try
               {
                   // Obrir connexió  
                   conn.Open();

                   // Validar usuari
                   SqlCommand cmd = new SqlCommand("ModificarUsuari", conn);
                   cmd.CommandType = CommandType.StoredProcedure;

                   SqlParameter p0 = new SqlParameter("@Id", id);
                   p0.SqlDbType = SqlDbType.Int;
                   p0.Direction = ParameterDirection.Input;
                   cmd.Parameters.Add(p0);
                   
                   SqlParameter p1 = new SqlParameter("@Nom", usuari);
                   p1.SqlDbType = SqlDbType.Char;
                   p1.Direction = ParameterDirection.Input;
                   cmd.Parameters.Add(p1);

                   SqlParameter p2 = new SqlParameter("@ParaulaClau", password);
                   p2.SqlDbType = SqlDbType.Char;
                   p2.Direction = ParameterDirection.Input;
                   cmd.Parameters.Add(p2);

                   SqlParameter p3 = new SqlParameter("@Perfil", perfil);
                   p3.SqlDbType = SqlDbType.Int;
                   p3.Direction = ParameterDirection.Input;
                   cmd.Parameters.Add(p3);

                   cmd.ExecuteNonQuery();

                   conn.Close();
               }
               catch (Exception e)
               {
                   MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
               }
           }

           public void EliminarUsuari(int id)
           {
               try
               {
                   // Obrir connexió  
                   conn.Open();

                   // Validar usuari
                   SqlCommand cmd = new SqlCommand("EliminarUsuari", conn);
                   cmd.CommandType = CommandType.StoredProcedure;

                   SqlParameter p0 = new SqlParameter("@Id", id);
                   p0.SqlDbType = SqlDbType.Int;
                   p0.Direction = ParameterDirection.Input;
                   cmd.Parameters.Add(p0);
                   
                   cmd.ExecuteNonQuery();

                   conn.Close();
               }
               catch (Exception e)
               {
                   MessageBox.Show(e.Source + ": " + e.Message, "CubeExplorer");
               }
           }  




    }
}
