﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace CubeExplorerUI
{
    
    /// <summary>
    /// Lógica de interacción para UsuarisWnd.xaml
    /// </summary>
    public partial class UsuarisWnd : Window
    {
        public int id { get; set; }
        public string nom { get; set; }
        public string password { get; set; }
        public int perfil { get; set; }
        public int mode;

        public event AceptarUsuariHandler  OnAceptarUsuari;
        public event CancelarUsuariHandler OnCancelarUsuari;

        public UsuarisWnd()
        {
            InitializeComponent();
        }

        public void Initialize(int mode)
        {
            this.mode = mode;
            txtId.Text = Convert.ToString(id);
            txtNom.Text = nom;
            pbeUsuari.Text = password;
            switch (perfil)
            {
                case 1:
                    rbAdmin.IsChecked = true;
                    break;
                case 2:
                    rbDes.IsChecked = true;
                    break;
                case 3:
                    rbUser.IsChecked = true;
                    break;
            }
        }

        private void btnAceptar_Click(object sender, RoutedEventArgs e)
        {
            nom = txtNom.Text;
            password = pbeUsuari.Text;
           
            if (rbAdmin.IsChecked == true) {
                perfil = 1;
            }

            if (rbDes.IsChecked == true) {
                perfil = 2;
            }

            if (rbUser.IsChecked == true) {
                perfil = 3;
            }

            OnAceptarUsuari(id, nom, password, perfil); 

        }

        private void btnCancelar_Click(object sender, RoutedEventArgs e)
        {
            OnCancelarUsuari(id, mode);
        }
    }
}
